<?php

use NoccyLabs\JsonEdit\Settings;

require_once __DIR__."/../vendor/autoload.php";

define("SETTINGS_FILE", getenv("HOME")."/.config/jsonedit/config.json");

$filename = $argv[1]??null;

$terminal = new NoccyLabs\JsonEdit\Terminal\Terminal();

Settings::load(SETTINGS_FILE);

$editor = new NoccyLabs\JsonEdit\Editor\Editor($terminal);
if ($filename) {
    $editor->loadFile($filename);
} else {
    $editor->loadDocument((object)[]);
}


set_exception_handler(function (\Throwable $t) use ($terminal) {
    register_shutdown_function(function () use ($t, $terminal)  {
        $terminal->shutdown();
        echo $t."\n";    
    });
});

$editor->run();
